/*JAWS scripts for the DECtalk speak window version 4.3
Author: Jitendra, (the ultrauniverse.co.cc).
URL: Http://www.ultrauniverse.co.cc
May 2012.
I created these scripts because I have faced problems using the speak window, specially clicking the icons for play, pause and stop.
These scripts contains no autostart event function, since when enter is pressed, it automaticly starts speaking or singing, if a file is found, or an error is spoken, so at that time, JAWS may prevent user from getting the hands on what DECtalk is saying.*/
Include "hjconst.jsh" ; default HJ constants
Include "common.jsm"
Include "Speak.jsm"
Const
Wm_command=273 ;windows message
Globals
Int Switch,
int iListIndex
Void Function AutoStartEvent ()
If StringLower (GetWindowClass (GetFocus ( ))) == "edit" then
EndIf
Pause ()
;WindowMaximize (GetFocus ())
WindowMaximize (GetRealWindow (GetFocus ( )))
SayString ("Press JAWS key Plus H for hotkeys.")
EndFunction

Int Function WindowMaximize (handle HFocus)
Var
Int iMessage, Int iParam
If !hFocus Then
Let hFocus = GetFocus()
EndIf
Let iMessage = 0x112 ;WM_SYSCOMMAND
Let iParam = 0xF030 ;SC_MAXIMIZE
Return SendMessage(hFocus, iMessage, iParam, 0)
EndFunction

Void Function MenuCommand (int ItemID)
SendMessage (GetAppMainWindow (GetFocus ()), WM_Command, ItemID )
EndFunction
Int Function ButtonClick (handle Hwnd)
;Activate a button
Var
Int BM_CLICK
If !hwnd Then
SayString ("Button was not found!")
Return
EndIf
Let BM_CLICK=245
Return SendMessage(hwnd, BM_CLICK, 0, 0)
EndFunction
Script ScriptFileName ()
ScriptAndAppNames ("DECtalk Speak window 4.3")
EndScript
HANDLE Function ReturnStartingWindow ()
Var
Handle Hwnd,
Handle grip
let hwnd = GetAppMainWindow (GetCurrentWindow ())
Let grip = GetFirstChild (hwnd)

Return Grip
EndFunction

Script PlayButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <5) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
SayString ("Play Button")
EndScript

Script PauseButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <6) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript

Script StopButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <7) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
SayString ("Stop")
EndScript

Script PauleButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <8) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript
Script FrankButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <9) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript

Script UrsulaButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <10) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript

Script BettyButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <11) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript

Script DennisButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <12) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript


Script RitaButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <13) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript

Script HarryButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <14) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript

Script KitButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <15) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript

Script WendyButton ()
Var
Int I1,
Handle Grip
Let Grip = ReturnStartingWindow ()
let I1 = 1
While ( I1 <16) 
Let grip = GetNextWindow (grip)
Let I1 = I1+1
EndWhile
ButtonClick (Grip)
EndScript
;following scripts are taken from the previous code, sorry, I forgot the name of the person.
Script BottomOfFile ()
SayString("bottom")
{Control+End}
SayLine()
EndScript

Script SaveText ()
SpeechOff()
{Alt+F}
Pause()
{S}
Delay(1)
SpeechOn()
SayString("save text")
EndScript

Script SaveWave ()
If DialogActive() then
	TypeCurrentScriptKey()
	Return
Endif
SpeechOff()
{alt+F}
{c} {c}
{enter} {Enter}
Delay(1)
SpeechOn()
SayString("save wave")
EndScript
Script OpenTextFile ()
If DialogActive() then
	TypeCurrentScriptKey()
	Return
Endif
SpeechOff()
{Alt+F}
{DownArrow}
{Enter}
Pause()
SpeechOn()
EndScript

Script TopOfFile ()
SayString("top")
{control+Home}
SayLine()
EndScript
Script VoiceSelection ()
SpeechOff()
{Alt+L}
Delay(1)
{enter}; set the language to English, I'm not going to make exceptions for 11 languages!
SpeechOn()
Var
	String sVoicelist
if InHJDialog () then
	SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
	return
endIf
let sVoicelist="Paul|Betty|Harry|Frank|Dennis|Kit|Ursula|Rita|Wendy"
If !iListIndex then; it hasn't been used before during this session.	Let iListIndex=1; Paul will be selected by default.
Endif
Let iListIndex=DlgSelectItemInList (sVoicelist, "Voice Picker", 0, iListIndex, "", -1); recall the previously used voice if used.
If iListIndex then
;Get the hard stuff out of the way
	SpeechOff()
{Alt+V}
	If iListIndex==1 then
		{P}
	ElIf iListIndex==2 then
		{B}
	ElIf iListIndex==3 then
		{h}
	ElIf iListIndex==4 then
		{F}
	ElIf iListIndex==5 then
		{D}
	ElIf iListIndex==6 then
		{K}
	Elif iListIndex==7 then
		{U}
	Elif iListIndex==8 then
		{R}
	Elif IListIndex==9 then
		{W}
	EndIf
	Delay(1)
	SpeechOn()
Else 
	SayString("Canceled!")
Endif
EndScript
Script HotkeyHelp ()
If UserBufferIsActive () then
UserBufferDeactivate ()
EndIf
SayMessage (OT_User_Buffer, Hotkeys )
EndScript